#################################
#    CMFSubversionBrowser
#    Copyright (C) 2002  kapil thangavelu
#
#    This product is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This product is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this product; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#################################

"""
Purpose: Register cmf svn browser with portal
Author: kapil thangavelu <kvthan@wm.edu>
CVS: $Id: Install.py,v 1.1.1.1 2002/10/21 13:10:27 k_vertigo Exp $
"""

from Products.CMFSubversionBrowser import ContentProductId, ContentFTI, ContentSkins, ContentOverride

# everything below is generic

def install(self):
    
    from cStringIO import StringIO
    from Products.CMFCore.utils import getToolByName
    from Products.CMFCore.TypesTool import FactoryTypeInformation as fti_klass

    global ContentProductId, ContentFTI, ContentSkins, ContentOverride

    skins  = getToolByName(self, 'portal_skins')
    types  = getToolByName(self, 'portal_types')

    log = StringIO()
    print >> log, "Registering %s"%ContentProductId

    #################################
    # register skins
    print >> log, "Register %s DirectoryViews"%ContentProductId
    for skin in ContentSkins:
        if skin in skins.objectIds():
            continue
        
        skins.manage_addProduct['CMFCore'].manage_addDirectoryView(
            filepath = "Products/%s/%s"%(ContentProductId, skin)
            )
        
        print >> log, "Registered %s Directory View"%skin

    #################################
    # add to default skin
    
    skin_name = skins.getDefaultSkin()
    skin_path = skins.getSkinPath(skin_name)
    components = map(lambda x: x.strip(), skin_path.split(','))

    for skin in ContentSkins:
        if not skin in components:
            components.insert(1, skin)
            
    new_skin_path = ', '.join(components)
    if new_skin_path != skin_path:
        skins.addSkinSelection(skin_name, new_skin_path, make_default=1)
        print >> log, "Added Views to Default Skin"

    #################################
    # register types
    print >> log, "Registering Types"

    for ti in ContentFTI:

        if ti['id'] in types.objectIds():
            if ContentOverride:
                print >> log, "Overriding Content Type %s"%ti['id']
                types._delObject(ti['id'])
            else:
                continue
        
        typeinfo_name = "%s: %s"%(ContentProductId, ti['meta_type'])
        types.manage_addTypeInformation(
            add_meta_type = fti_klass.meta_type,
            id = ti['id'],
            typeinfo_name = typeinfo_name
            )
                                                   
        print >> log, "Registered %s"%ti['id']

    print >> log, "Successfully Registered %s"%ContentProductId
    return log.getvalue()



    
