#################################
#    CMFSubversionBrowser
#    Copyright (C) 2003-2004  kapil thangavelu <k_vertigo@objectrealms.net>
#
#    This product is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This product is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this product; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#################################
"""
Purpose: CMF variant of SVN Browser object model
Author: kapil thangavelu <k_vertigo@objectrealms.net>
$Id: TypeInfo.py,v 1.3 2003/02/28 05:16:23 k_vertigo Exp $
"""

from Products.CMFCore import CMFCorePermissions

svn_browser_fti = {
    'id'             : 'SubversionBrowser'
    , 'meta_type'      : 'CMF Subversion Browser'
    , 'description'    : 'Browses the Contents of a Subversion Repository'
    , 'icon'           : 'svn_browser.png'
    , 'product'        : 'CMFSubversionBrowser'
    , 'factory'        : 'addCMFSubversionBrowser'
    , 'filter_content_types' : 1
    , 'allowed_content_types':[]
    , 'immediate_view' : 'svn_browser_edit_form'
     , 'actions'        :
        ( { 'id'            : 'view' 
          , 'name'          : 'View'
          , 'action'        : 'string:${object_url}/svn_browser_view'
          , 'permissions'   :
             (CMFCorePermissions.View,)
          , 'category'      : 'object'
          }
          
        , { 'id'            : 'edit'
           , 'name'          : 'Edit'
          , 'action'        : 'string:${object_url}/svn_browser_edit_form'
          , 'permissions'   :
             (CMFCorePermissions.ModifyPortalContent,)
          , 'category'      : 'object'
          }          

        , { 'id'            : 'history'
           , 'name'          : 'History'
          , 'action'        : 'string:${object_url}/svn_browser_history'
          , 'permissions'   :
             (CMFCorePermissions.View,)
          , 'category'      : 'object'
          }

        , { 'id'            : 'revision_map'
           , 'name'          : 'Revision Map'
          , 'action'        : 'string:${object_url}/svn_revision_view'
          , 'permissions'   :
             (CMFCorePermissions.View,)
          , 'condition'     : 'python: request.URL.count("svn_revision_view")>0'
          , 'category'      : 'object'
          }          

       , { 'id'             : 'metadata'
          , 'name'          : 'Metadata'
          , 'action'        : 'string:${object_url}/metadata_edit_form'
          , 'permissions'   :
           (CMFCorePermissions.ManageProperties,)
          , 'category'      : 'object'
          }
      )
    }

svn_directory_fti = {
    'id'             : 'SubversionDirectory'
    , 'meta_type'      : 'CMF Subversion Directory'
    , 'description'    : 'Browses the Contents of a Subversion Directory'
    , 'icon'           : 'svn_directory.png'
    , 'product'        : 'CMFSubversionBrowser'
    , 'factory'        : 'null_factory'
    , 'filter_content_types' : 1
    , 'allowed_content_types':[]
    , 'global_allow'   : 0
    , 'immediate_view' : 'svn_directory_view'
     , 'actions'        :
        ( { 'id'            : 'view' 
          , 'name'          : 'View'
          , 'action'        : 'string:${object_url}/svn_directory_view'
          , 'permissions'   :
             (CMFCorePermissions.View,)
          , 'category'      : 'object'
          }
          
        , { 'id'            : 'revisions'
          , 'name'          : 'Revisions'
          , 'action'        : 'string:${object_url}/svn_resource_revisions'
          , 'permissions'   :
             (CMFCorePermissions.View,)
          , 'category'      : 'object'
          }

        , { 'id'            : 'properties'
          , 'name'          : 'Properties'
          , 'action'        : 'string:${object_url}/svn_resource_properties'
          , 'condition'     : 'object/getProperties'
          , 'permissions'   :
             (CMFCorePermissions.View,)
          , 'category'      : 'object'
          }
          
          )
    }
    

svn_file_fti = {
    'id'             : 'SubversionFile'
    , 'meta_type'      : 'CMF Subversion File'
    , 'description'    : 'Browses the Contents of a Subversion File'
    , 'icon'           : 'svn_file.png'
    , 'product'        : 'CMFSubversionBrowser'
    , 'factory'        : 'null_factory'
    , 'filter_content_types' : 1
    , 'allowed_content_types':[]
    , 'global_allow'   : 0
    , 'immediate_view' : 'svn_file_view'
     , 'actions'        :
    
        ( { 'id'            : 'view' 
          , 'name'          : 'View'
          , 'action'        : 'string:${object_url}/svn_file_view'
          , 'permissions'   :
             (CMFCorePermissions.View,)
          , 'category'      : 'object'
          }
          
        , { 'id'            : 'revisions'
          , 'name'          : 'Revisions'
          , 'action'        : 'string:${object_url}/svn_resource_revisions'
          , 'permissions'   :
             (CMFCorePermissions.View,)
          , 'category'      : 'object'
          }

        , { 'id'            : 'properties'
          , 'name'          : 'Properties'
          , 'action'        : 'string:${object_url}/svn_resource_properties'
          , 'condition'     : 'object/getProperties'
          , 'permissions'   :
             (CMFCorePermissions.View,)
          , 'category'      : 'object'
          }

       , { 'id'             : 'download'
          , 'name'          : 'Download'
          , 'action'        : 'string:${object_url}/svn_file_download'
          , 'permissions'   :
           (CMFCorePermissions.ManageProperties,)
          , 'category'      : 'object'
          }
          
       , { 'id'             : 'annotate'
          , 'name'          : 'Annotated'
          , 'action'        : 'string:${object_url}/svn_file_annotate'
          , 'condition'     : 'python: not object.isBinary()'  
          , 'permissions'   :
           (CMFCorePermissions.View,)
          , 'category'      : 'object'
          }          
      )
    }
