#################################
#    CMFSubversionBrowser
#    Copyright (C) 2002-2004  kapil thangavelu <k_vertigo@objectrealms.net>
#
#    This product is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This product is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this product; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#################################

"""
Purpose: Initialize and Register the Browser with Zope/CMF
Author: kapil thangavelu <k_vertigo@objectrealms.net>
$Id: __init__.py,v 1.2 2003/02/03 00:04:36 k_vertigo Exp $
"""

from Globals import package_home
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import ContentInit
from Products.CMFCore.DirectoryView import registerDirectory

import CMFSubversionBrowser
import TypeInfo
import Script

ContentFTI = (TypeInfo.svn_browser_fti,
              TypeInfo.svn_directory_fti,
              TypeInfo.svn_file_fti)

ContentClasses = (CMFSubversionBrowser.CMFSubversionBrowser,
                  CMFSubversionBrowser.CMFSubversionDirectory,
                  CMFSubversionBrowser.CMFSubversionFile)

ContentConstructors = (CMFSubversionBrowser.addCMFSubversionBrowser,
                       CMFSubversionBrowser.null_factory,
                       CMFSubversionBrowser.null_factory)

ContentProductId = 'CMFSubversionBrowser'
ContentSkins = ['svn_browser']
ContentOverride = 1

ProductHome = package_home( globals() )

for sd in ContentSkins:
    registerDirectory(sd, globals())



def initialize(context):

    ContentInit(
        meta_type=ContentProductId,
        content_types = ContentClasses,
        permission = CMFCorePermissions.AddPortalContent,
        fti = ContentFTI,
        extra_constructors = ContentConstructors
        ).initialize(context)
