#################################
#    CMFSubversionBrowser
#    Copyright (C) 2002-2004  kapil thangavelu <k_vertigo@objectrealms.net>
#
#    This product is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This product is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this product; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#################################

"""
Purpose: Utility methods 
Author: kapil thangavelu <pluto@objectrealms.net>
$Id: utils.py,v 1.3 2003/02/28 05:17:36 k_vertigo Exp $
"""

def svn_path_id( svnpath ):
    idx=svnpath.rfind('/')
    if not idx:
        id = svnpath.strip()
    else:
        id = svnpath[idx+1:]

    return id

def svn_path_join(*args):
    return "/%s"%'/'.join(filter(None, '/'.join(args).split('/')))

class charbuffer:
    def __init__(self):
        self.data = []
    def write(self, d):
        self.data.append(d)
    def getvalue(self):
        return ''.join(self.data)

class wrap:
    def __init__(self, o):
        self.o = o
    def __call__(self, v):
        return v.__of__(self.o)

def sort_by_id(obj1, obj2):
    return cmp(obj1.getId(), obj2.getId())

# tools for type infos

def merge_object_models(target_klass,
                        target_fti,
                        source_klass,
                        source_fti,
                        order=-1):

    bases = list(target_klass.__bases__)
    bases.insert(order, source_klass)
    target_klass.__bases__ = tuple(bases)

    bases = list( target_fti.__bases__ )
    # xxx assumption about fti inheritance
    bases.insert(0, source_fti)
    target_fti.__bases__ = tuple(bases)

    
def klassify_type_info(ti=None, **kw):
    class kti: pass
    if ti is None:
        ti = kw
    return kti().__dict__.update(ti)
        
def initialize_type_info(klass):
    ti = {}
    # this lookup is linear, no multiple inheritance...
    bases = klass.__bases__
    bases.reverse()
    bases.append(klass)
    
    for b in bases:
        ti.update(b.__dict__)

    return ti
